//
// C++ Implementation: itpp_ext
//
// Description:
//
//
// Author: smidl <smidl@utia.cas.cz>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "user_info.h"

namespace bdm {

UI::Class_To_UI::Class_To_UI_Map& UI::Class_To_UI::private_map()
{
	static Class_To_UI_Map var;
	return var;
}

void UI::Class_To_UI::add_class( const string &class_name, UI* ui )
{
	private_map().insert( make_pair( class_name, ui ) );
}

UI* UI::Class_To_UI::retrieve_ui( const string &class_name )
{
	Class_To_UI_Map::const_iterator iter = private_map().find( class_name );
	if( iter == private_map().end()) return NULL;
	else return iter->second;
}	

//////////////////////////////////////////////////////////////////////


UI_File::UI_File ( const string &file_name ) : file_name( file_name )
{
	setAutoConvert( true );
}

//! loads root element from a file
void UI_File::load() 
{
	try
	{
		readFile( file_name.c_str()  );
	}
	catch ( FileIOException f ) 
	{
		it_error ( "UI error: file " + file_name + " not found." );
	}
	catch ( ParseException& P ) 
	{
		stringstream msg;
		msg << "UI error: parsing ui_error """ << P.getError() << """ in file " << file_name << " on line " <<  P.getLine() << ".";
		it_error ( msg.str() );
	}	
}


//! save UserInfo to the file (typically with an XML extension)
void UI_File::save()
{
	try
	{
		writeFile ( file_name.c_str()  );
	}
	catch ( FileIOException f ) 
	{
		it_error( "UI error: file " + file_name + " is inacessible." );
	}		
}	

UI_File::operator Setting&()
{
	return getRoot();
}

}

